#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<math.h>

#include	<tsdb.h>
#include	<ace/lisp.h>
#include	<assert.h>

int ncues_total=0;

struct s_exp	*get_key(struct s_exp	*alist, char	*key)
{
	int i;
	assert(alist->type == s_exp_list);
	for(i=0;i<alist->len;i++)
	{
		struct s_exp	*s = alist->list[i];
		assert(s->type == s_exp_cons || (s->type == s_exp_list && s->len > 1));
		struct s_exp	*sk = s->list[0];
		struct s_exp	*sv = s->list[1];
		assert(sk->type == s_exp_id);
		if(!strcasecmp(sk->value, key))
			return sv;
	}
	fprintf(stderr, "no such key '%s'\n", key);
	exit(-1);
}

char	*get_key_str(struct s_exp	*alist, char	*key)
{
	struct s_exp	*s = get_key(alist, key);
	assert(s != NULL);
	return s->value;
}

main(int	argc, char	*argv[])
{
	assert(argc>=2);
	struct tsdb	*T = load_tsdb(argv[1]);
	struct relation	*item = get_relation(T, "item");
	int	i_id = get_field(item, "i-id", "integer");
	int	i_comment = get_field(item, "i-comment", "string");
	int	i_tokens = get_field(item, "i-tokens", "string");
	struct relation	*parse = get_relation(T, "parse");
	int	p_i_id = get_field(parse, "i-id", "integer");
	int p_p_id = get_field(parse, "parse-id", "integer");
	struct relation	*result = get_relation(T, "result");
	int	r_id = get_field(result, "result-id", "integer");
	int	r_p_id = get_field(result, "parse-id", "integer");
	int r_deriv = get_field(result, "derivation", "string");
	int r_mrs = get_field(result, "mrs", "string");
	int r_flags = get_field(result, "flags", "string");
	int i;
	for(i=0;i<item->ntuples;i++)
	{
		char	*id = item->tuples[i][i_id];
		char	*i_tokens_str = item->tuples[i][i_tokens];
		struct s_exp *lisp_toklist = parse_lisp(&i_tokens_str, 1);
		char	*comment = item->tuples[i][i_comment];
		if(!*comment)
			continue;
		struct s_exp	*s = parse_lisp(&comment, 1);
		assert(s != NULL);
		assert(s->type = s_exp_list && s->len == 3);
		struct s_exp	*s_nscopes = s->list[1];
		struct s_exp	*s_ncues = s->list[2];
		assert(s_nscopes->type == s_exp_list && s->len > 0);
		assert(s_ncues->type == s_exp_list && s->len > 0);
		assert(s_nscopes->list[0]->type == s_exp_id);
		assert(!strcasecmp(s_nscopes->list[0]->value, ":nscopes"));
		assert(s_ncues->list[0]->type == s_exp_id);
		assert(!strcasecmp(s_ncues->list[0]->value, ":ncues"));
		if(s->len == 1)continue;


		int j;
		for(j=1;j<s_ncues->len;j++)
			ncues_total++;
	}
	printf("%d cues total\n", ncues_total);
}
