#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<ace/tree.h>

static int	heads_nrules;
static char	*heads_rules[1000];
static int		heads_heads[1000];

int	headedness_for_rule(char	*rname)
{
	if(!heads_nrules)
	{
		FILE	*f = fopen("erg.hds", "r");
		if(!f) { perror("erg.hds"); return 0; }
		char	name[1024];
		int		arity, head;
		while(3 == fscanf(f, "%[^ \t] %d %d\n", name, &arity, &head))
		{
			heads_rules[heads_nrules] = strdup(name);
			heads_heads[heads_nrules] = head;
			heads_nrules++;
		}
		fclose(f);
	}
	int i;
	for(i=0;i<heads_nrules;i++)
		if(!strcmp(rname, heads_rules[i]))return heads_heads[i];
	fprintf(stderr, "no such rule '%s' found!\n", rname);
	return 0;
}

int	is_terminal(struct tree	*t)
{
	if((t->ndaughters>=1 && t->daughters[0]->ndaughters==0) ||
		(t->ndaughters>1 && t->daughters[1]->ndaughters==0))
		return 1;
	else return 0;
}

struct tree	*tree_lex_head(struct tree	*t)
{
	if(t->lexhead)return t->lexhead;
	if(!t->ndaughters)return t->lexhead = t->parent;
	if(is_terminal(t))
		return t->lexhead = t;
	if(t->ndaughters == 1)
		return t->lexhead = tree_lex_head(t->daughters[0]);
	int	h = headedness_for_rule(t->label);
	return t->lexhead = tree_lex_head(t->daughters[h]);
}
